Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.search
Class ExistenceQualification

    java.lang.Object
      oracle.ifs.search.SearchQualification
          oracle.ifs.search.ExistenceQualification

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class ExistenceQualification

extends SearchQualification

ExistenceQualification represents a Simple Sub Query. This qualification provides a way to specify a search an attribute value match against a list of values. On the left hand side of this qualification is any scalar attribute of a iFS class. We do not support array attributes as of current release. On the right hand side the list of values could come from any iFS attriute (scalar or array type) or from a user supplied AttributeValue array.

>      //
>      // Usage Examples
>      //
>      // Simple sub query example. Suppose you want to look for,
>      // All documents whose name appears in STRINGVALUE attribute of any PROPERTY
>      // Generates query  - DOCUMENT.Name in (select STRINGVALUE from PROPERTY)
>      // This shows scalar attributes on both LHS and RHS.
>      //
>      ExistenceQualification eq1 = new ExistenceQualification();
>      eq1.setLeftAttribute(Document.CLASS_NAME, PublicObject.NAME_ATTRIBUTE);
>      eq1.setRightAttribute(Property.CLASS_NAME, Property.STRINGVALUE_ATTRIBUTE);
>      //
>      // Using the a array type attribute on the right hand side
>      // Suppose you want to look for, all documents whose name appears in
>      // STRINGVALUES array type attribute in a property.
>      // Generates query - DOCUMENT.Name in (select STRINGVALUES[] from PROPERTY)
>      // This flattens out the array attribute on the right hand side and generates
>      // a concatenated list of all values in STRINGVALUES attribute in each row.
>      //
>      ExistenceQualification eq1 = new ExistenceQualification();
>      eq1.setLeftAttribute(Document.CLASS_NAME, PublicObject.NAME_ATTRIBUTE);
>      eq1.setRightAttribute(Property.CLASS_NAME, Property.STRINGVALUES_ATTRIBUTE);
>      //
>      // User supplied AttributeValues on the RHS
>      // Suppose you want to look for documents whose name is in {"FOO", "BAR", "NOTES"},
>      // then you use the EQ in the following manner.
>      //
>      // First generate the list of values.
>      AttributeValue [] avArray = new AttributeValue[3];
>      avArray[0] = AttributeValue.newAttributeValue("FOO");
>      avArray[1] = AttributeValue.newAttributeValue("BAR");
>      avArray[2] = AttributeValue.newAttributeValue("NOTES");
>      //
>      // Then use the list in a EQ.
>      ExistenceQualification eq1 = new ExistenceQualification();
>      eq1.setLeftAttribute(Document.CLASS_NAME, PublicObject.NAME_ATTRIBUTE);
>      eq1.setRightAttributeValue(avArray);

See Also:
  Serialized Form
(Published)

Field Summary
`protected java.lang.String` | `m_LeftAttribute` Holds the Left hand side attribute.
`protected java.lang.String` | `m_LeftClass` This holds the iFS class name for the left hand side.
`protected java.lang.String` | `m_RightAttribute` Holds the Right hand side attribute.
`protected boolean` | `m_RightAttributeMV` Holds true if the right hand side is a Multi value attribute.
`protected Attribute` | `m_RightAttributeObject` Holds the actual attribute value representing the right attribute.
`protected java.lang.String` | `m_RightClass` This holds the iFS class name for the right hand side.
`protected boolean` | `m_StaticType` Holds the type of EQ this is.
`protected AttributeValue[]` | `m_Values` Holds the Attribute Value array supplied by the user.

Fields inherited from class oracle.ifs.search.SearchQualification
`LATE_BIND_OPER`

Constructor Summary
`ExistenceQualification()` Constructs an existence qualification.

Method Summary
`protected void` | `accept(oracle.ifs.search.SearchQualificationVisitor v)` Accepts a SearchQualificationVisitor.
`java.lang.Object` | `clone()` Returns a clone of this SearchQualification.
`java.lang.String` | `getLeftAttributeName()` Gets the left hand side Attribute name.
`java.lang.String` | `getLeftClassname()` Gets the left hand side class name.
`protected int` | `getRightAttributeDataType()` Gets the data type of the the object on RHS.
`java.lang.String` | `getRightAttributeName()` Gets the right hand side Attribute name.
`protected Attribute` | `getRightAttributeObject()` Returns the actual attribute object of the RHS.
`AttributeValue[]` | `getRightAttributeValue()` Gets up the Attribute value array for the right hand side.
`java.lang.String` | `getRightClassname()` Gets the Right hand side class name.
`protected AttributeValue[]` | `getValues()` Returns the AttributeValue array of RHS.
`protected boolean` | `isRightAttributeMV()` Returns true if the right attribute is a MV.
`boolean` | `isRightAttributeValue()` Gets true if the ExistenceQualification was constructed by supplying an Attribute Value array for RHS.
`void` | `setLeftAttribute(java.lang.String classname, java.lang.String attribute)` Sets the left hand side class and attribute name of this qualification.
`protected void` | `setLeftClass(java.lang.String className)` Sets the left hand side class name.
`void` | `setRightAttribute(java.lang.String classname, java.lang.String attribute)` Sets the right hand side class and attribute name of this qualification.
`protected void` | `setRightAttributeMV(boolean value)` Sets the flag to indicate right attribute is MV.
`protected void` | `setRightAttributeObject(Attribute attr)` Sets the actual attribute corresponding to to the RHS.
`void` | `setRightAttributeValue(AttributeValue[] avArray)` Sets up the Attribute value array for the right hand side.

Methods inherited from class oracle.ifs.search.SearchQualification
`isLateBound`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_LeftClass

    protected java.lang.String m_LeftClass

  Description copied from class: `ExistenceQualification`
  This holds the iFS class name for the left hand side.

  (Unpublished)

### m_RightClass

    protected java.lang.String m_RightClass

  Description copied from class: `ExistenceQualification`
  This holds the iFS class name for the right hand side.

  (Unpublished)

### m_LeftAttribute

    protected java.lang.String m_LeftAttribute

  Description copied from class: `ExistenceQualification`
  Holds the Left hand side attribute.

  (Unpublished)

### m_RightAttribute

    protected java.lang.String m_RightAttribute

  Description copied from class: `ExistenceQualification`
  Holds the Right hand side attribute.

  (Unpublished)

### m_RightAttributeMV

    protected boolean m_RightAttributeMV

  Description copied from class: `ExistenceQualification`
  Holds true if the right hand side is a Multi value attribute.

  (Unpublished)

### m_RightAttributeObject

    protected transient Attribute m_RightAttributeObject

  Description copied from class: `ExistenceQualification`
  Holds the actual attribute value representing the right attribute.

  (Unpublished)

### m_StaticType

    protected boolean m_StaticType

  Description copied from class: `ExistenceQualification`
  Holds the type of EQ this is. Static Vs Normal.

  (Unpublished)

### m_Values

    protected AttributeValue[] m_Values

  Description copied from class: `ExistenceQualification`
  Holds the Attribute Value array supplied by the user.

  (Unpublished)

Constructor Detail

### ExistenceQualification

    public ExistenceQualification()
                           throws IfsException

  Constructs an existence qualification.

  Throws:
    `IfsException` - if the operation fails
  (Published)

Method Detail

### setLeftAttribute

    public void setLeftAttribute(java.lang.String classname,
                                 java.lang.String attribute)
                          throws IfsException

  Description copied from class: `ExistenceQualification`
  Sets the left hand side class and attribute name of this qualification. The class name used here should be one of the search classes.

  Parameters:
    `classname` - left hand side class name
    `attribute` - left hand side attribute name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setRightAttribute

    public void setRightAttribute(java.lang.String classname,
                                  java.lang.String attribute)
                           throws IfsException

  Description copied from class: `ExistenceQualification`
  Sets the right hand side class and attribute name of this qualification. The class used here need not be in the list of search classes because, it is used in a separate sub query.

  Parameters:
    `classname` - right hand side class name
    `attribute` - right hand side attribute name
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setRightAttributeValue

    public void setRightAttributeValue(AttributeValue[] avArray)
                                throws IfsException

  Description copied from class: `ExistenceQualification`
  Sets up the Attribute value array for the right hand side. Use this method to set up user supplied values for the right hand side.

  Parameters:
    `avArray` - array of attribute values
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRightAttributeValue

    public AttributeValue[] getRightAttributeValue()
                                            throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets up the Attribute value array for the right hand side.

  Returns:
    array of attribute values
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getLeftClassname

    public java.lang.String getLeftClassname()
                                      throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets the left hand side class name.

  Returns:
    Name of the left hand side iFS class.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setLeftClass

    protected void setLeftClass(java.lang.String className)

  Description copied from class: `ExistenceQualification`
  Sets the left hand side class name.

  (Unpublished)

### getRightClassname

    public java.lang.String getRightClassname()
                                       throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets the Right hand side class name.

  Returns:
    Name of the right hand side iFS class.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getLeftAttributeName

    public java.lang.String getLeftAttributeName()
                                          throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets the left hand side Attribute name.

  Returns:
    Name of the left hand side attribute.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getRightAttributeName

    public java.lang.String getRightAttributeName()
                                           throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets the right hand side Attribute name.

  Returns:
    Name of the right hand side attribute.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### setRightAttributeMV

    protected void setRightAttributeMV(boolean value)

  Description copied from class: `ExistenceQualification`
  Sets the flag to indicate right attribute is MV.

  Parameters:
    `value` - Value of the flag.
  (Unpublished)

### isRightAttributeMV

    protected boolean isRightAttributeMV()

  Description copied from class: `ExistenceQualification`
  Returns true if the right attribute is a MV.

  (Unpublished)

### setRightAttributeObject

    protected void setRightAttributeObject(Attribute attr)

  Description copied from class: `ExistenceQualification`
  Sets the actual attribute corresponding to to the RHS. Internal use only.

  Parameters:
    `attr` - Attribute corresponding to the RHS.
  (Unpublished)

### getRightAttributeObject

    protected Attribute getRightAttributeObject()

  Description copied from class: `ExistenceQualification`
  Returns the actual attribute object of the RHS. For internal use only.

  Returns:
    Attribute Attribute object for RHS.
  (Unpublished)

### getRightAttributeDataType

    protected int getRightAttributeDataType()
                                     throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets the data type of the the object on RHS. Internal use only.

  Returns:
    int DataType corresponding to the RHS.
  Throws:
    `IfsException`
  (Unpublished)

### isRightAttributeValue

    public boolean isRightAttributeValue()
                                  throws IfsException

  Description copied from class: `ExistenceQualification`
  Gets true if the ExistenceQualification was constructed by supplying an Attribute Value array for RHS.

  Returns:
    boolean True if the RHS list is a AV[] supplied by user.
  Throws:
    `IfsException` - if the operation fails
  (Published)

### getValues

    protected AttributeValue[] getValues()

  Description copied from class: `ExistenceQualification`
  Returns the AttributeValue array of RHS. Will return null if this object is not of static type.

  Returns:
    AttributeValue [] Attribute Value array of RHS.
  (Unpublished)

### accept

    protected void accept(oracle.ifs.search.SearchQualificationVisitor v)
                   throws IfsException

  Description copied from class: `ExistenceQualification`
  Accepts a SearchQualificationVisitor. Calls visitExistenceQualifier on the visitor. The code in visitExistenceQualifier is specific to the Visitor.

  Specified by:
    `accept` in class `SearchQualification`
  Parameters:
    `v` - SearchQualificationVisitor
  Throws:
    `IfsException` - thrown if Visitor code throws.
  (Unpublished)

### clone

    public java.lang.Object clone()

  Description copied from class: `ExistenceQualification`
  Returns a clone of this SearchQualification.

  Overrides:
    `clone` in class `SearchQualification`
  Returns:
    Return a clone of this ExistenceQualification.
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD